#
# Copyright 2008, Morisdov
#  		  morisdov@yahoo.com
#		  http://morisdov.googlepages.com
#
# License: 
#		Free for self use if you downloaded directly from http://morisdov.googlepages.com.
#		Permission to sell or redistribute or repackage this software 
#		should be specifically requested from the author.
#		above copyright notice should appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#
# Description:  control each scenes(pages) transition time for animations
#		
# Usage:	Menu Plugins-->Scenets Transition Times
#		 
#
# Installation: copy "proper_animation.rb"  into "Plugins" folder under SketchUp installation
#		restart SketchUp and note a new Plugins menu option
#		
# Version:	1.00, 27-July-2008
# Version:	1.01, 12-Dec-2009 D. Bur
#		http://morisdov.googlepages.com
#		
#
module Morisdov
#--------------------------------------------------------------------------------
def Morisdov.scenes_transition_times()
	@ps = []
	prompts = []
	@values = []
	@model=Sketchup.active_model
	npages=@model.pages.size
	@model.pages.each {|page| @ps.push(page);prompts.push(page.name+":     ") }
	@ps.each {|page| @values.push(page.transition_time) } #;puts("getting page" + page.name + ": " +page.transition_time.to_s) }	
	nboxes=(npages/5).ceil
	nlastbox=npages-(nboxes*5)
	@count=0
	@ind=0
	# Packs of 5 scenes
	0.upto(nboxes-1) do |box|
		boxprompts=[]
		boxvalues=[]
		results=[]
		0.upto(4) { |i| boxprompts.push(prompts[@count]);boxvalues.push(@values[@count]);@count+=1 }
		results = inputbox boxprompts, boxvalues, "Transitions entre scenes"
		return if !results
		0.upto(4) { |x| @ps[@ind+x].transition_time= results[x] } #; puts("Setting page " + (@ind+x).to_s + " to " + results [x].to_s + "seconds") }
		@ind+=5
	end
	#Last scenes
	boxprompts=[]
	boxvalues=[]
	results=[]
	@count-=1
	@ind-=1
	0.upto(nlastbox-1) do |box|
		boxprompts.push(prompts[@count])
		boxvalues.push(@values[@count])
		@count+=1
	end
	results = inputbox boxprompts, boxvalues, "Scenes Transitions"
	return if !results
	0.upto(nlastbox-1) { |x|	@ps[@ind+x].transition_time= results[x] } #; puts("Setting page " + (@ind+x).to_s + " to " + results [x].to_s + "seconds") }
end
#--------------------------------------------------------------------------------
if( not @scenes_transition_times_loaded )
   menu = UI.menu("View")
   UI.menu("View").add_separator
   menu.add_item("Scenes Transitions") { Morisdov.scenes_transition_times() }
   @scenes_transition_times_loaded = true
end
#--------------------------------------------------------------------------------
end # module
